// project created on 31.07.2006 at 11:05
// Karsten Burger (mailto: k.burger@burgernet.org)
// plugins based on ATK written by Marc Ruef (http://www.computec.ch)
// version 0.2 alpha ATKCE (Attack Tool Kit Consol Edition)
using System;
using System.IO;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;

namespace ConAppATK1
{
	class MainClass
	{
		//global objects and variables, it's not the professional programming style
		//there are only used for later compatibility to threads
		protected TcpClient c = null;
		protected NetworkStream inOut = null;
		protected int gintPort = 0;
		protected string gstrHost = null;
		protected string gstrCommandline = null;
 		
		public static void Main(string[] args)
		{
			if(args.Length != 2)
			{
				Console.WriteLine(" False count of parameters!\n e.x.: mono ConAppATK1.exe plugindir destination");

				Console.WriteLine("#####################################################");
				Console.WriteLine("## version: 0.2 alpha");
				Console.WriteLine("## To use the property icmp_alive you have to be systemadministrator/root.");
				Console.WriteLine("## Plugins based on ATK written by Marc Ruef (www.computec.ch)");
				Console.WriteLine("## e.x.: mono ConAppATK1.exe plugindir destination");
				Console.WriteLine("## Tipp: You can use the UNIX/Linux file operations for example \">\"");
				Console.WriteLine("## For more information see http://atkce.burgernet.org");
				Console.WriteLine("#####################################################");

				Console.WriteLine("This tool is written by Karsten Burger. \n For feedback, questions and suggestions mailto: k.burger@burgernet.org");
				Console.WriteLine(" weblog: weblog.burgernet.org");
				Console.WriteLine(" homepage: analyzernet.net.ms");

				return;
			}

			//Instanz
			MainClass vInstanz = new MainClass();
			
			//parameters two possibilities to check the plugin path (DirectoryNotFoundEx., or if file.exist())
			string strplugdir = args[0];			
			vInstanz.gstrHost = args[1];
			
			DirectoryInfo pluginsdir = null;
			
			try
			{
				//all plugins in the directory	
				pluginsdir = new DirectoryInfo(strplugdir);
				FileInfo[] plugins = pluginsdir.GetFiles();
				
				for (int i = 0; i< plugins.Length; i++)
				{
					//regular expression for the unix/linux backup file (filename~)
					Regex r1 = new Regex(".plugin~");
					MatchCollection mc = r1.Matches(plugins[i].ToString());
					int count = mc.Count;
					if(plugins[i].ToString() != "" && count == 0)
					{
						Console.WriteLine("-----------------------------------------------");
						Console.WriteLine("Start: " + plugins[i].ToString()); 
						vInstanz.vScan(plugins[i].ToString());
					}
				}				
			}
			//directory not found exception
			catch (DirectoryNotFoundException dnfexc)
			{
				Console.WriteLine("! Plugin directory not found. !");
			}
			catch (Exception exc)
			{
				Console.WriteLine(exc.ToString());
			}	
		}
		
		public void vScan(string strplugpath)
		{
			string[] strattributes; 			
			try
			{
				//read content
				using (StreamReader sr = new StreamReader(strplugpath))
				{
					string strinput = sr.ReadToEnd();
					strinput = strinput.Trim();
					strattributes = strinput.Split('\n');					
					bool bdetection = false;
					bool bexploit = false;
					for (int i = 0; i < strattributes.Length; i++)
					{
						//regex to find plugin_port
						Regex r1 = new Regex("plugin_port");
						MatchCollection mc = r1.Matches(strattributes[i]);
						int count = mc.Count;
						
						if (count > 0)
						{
							gintPort = Convert.ToInt32(mstrSplit(strattributes[i]));
						}						
						
						//regex to find plugin_procedure_detection (only for version >4)
						Regex r2 = new Regex("plugin_procedure_detection");
						mc = r2.Matches(strattributes[i]);
						count = mc.Count;
						if (count > 0)
						{
							gstrCommandline = mstrSplit(strattributes[i]);
							bdetection = true;
						}
						
						if (!bdetection)
						{
							//regex to find plugin_procedure_exploit (only for version >4 and no infos in plugin_procedure_detection)
							Regex r3 = new Regex("plugin_procedure_exploit");
							mc = r3.Matches(strattributes[i]);
							count = mc.Count;
							if (count > 0)
							{
								gstrCommandline = mstrSplit(strattributes[i]);
								bexploit = true;
							}
						}					
						
					}
					if (!bdetection && !bexploit)
					{
						//if no data, plugin is wrong
						Console.WriteLine("! The plugin is wrong, no plugin_procedure_detection or plugin_procedure_exploit tag. !");
						return;
					}
					vTCPSocket();
				}
			}
			catch (Exception exc)
			{
				Console.WriteLine(exc.ToString());
			}					
		}

		protected void vTCPSocket()
		{	
			//reorganisation commands
			string[] strtmp1 = gstrCommandline.Split('|');
			
			//Array for commands (send | sleep | ...)
			string[] strcommands = new string[strtmp1.Length - 1];
			
			//Array for the data
			string[] strcommanddata = new string[strtmp1.Length - 1];
			
			for (int i = 1; i < strtmp1.Length; i++)
			{
				string strtmp2 = strtmp1[i];
				string[] strtmp3 = strtmp2.Split(' ');

				//Command in strcommands
				strcommands[i-1] = strtmp3[0];

				if (strtmp3.Length > 1)
				{
					//Data to the commanddata-array
					if (strtmp3.Length == 2)
						strcommanddata[i-1] = strtmp3[1];
					else
					{
						//Remove the command from the string
						string strtmp4 = strcommands[i-1];
						int ilength = strtmp4.Length;
						string strtmp5 = strtmp1[i];
						strtmp5 = strtmp5.Remove(0, ilength + 1);
						strcommanddata[i-1] = strtmp5;						
					}
				}
				else
					strcommanddata[i-1] = "";
			}
			
			try
			{
				//TCP Client socket
				c = new TcpClient(gstrHost, gintPort);
				inOut = c.GetStream();
				Console.WriteLine("socket open: yes");
				
				//String for server output
				string strData = null;

				//Socket status
				bool bisOpen = true;
				bool bDataAv = false;
				
				//regular expression and matchcollection beacause more than one pattern exists
				Regex r1 = null;
				MatchCollection mc = null;
				
				//execute commands, if you have a better idea to handle the TcpClient please change it	
				for (int i = 0; i < strcommands.Length; i++)
				{
					if (i >=1)
					{
						//check if the tcp socket open, else open
						if (strcommands[i-1].ToString() == "close" && i != strcommands.Length-1)
						{
							c = new TcpClient(gstrHost, gintPort);
							inOut = c.GetStream();
							bisOpen = true;
							Console.WriteLine("socket open: yes");
						}
						
						//the property DataAviable only exist if the socket is open
						if (bisOpen)
						{
							//if the last command send or data aviable
							if(strcommands[i-1].ToString() == "send" || inOut.DataAvailable)
							{
								Console.WriteLine("data aviable: yes");
								
								//buffer size 9999, it's important to read all data in the stream for pattern exists
								byte[] buffer = new byte[9999];
								strData = "";

								//read 256 bytes
								int bytes = inOut.Read(buffer, 0, buffer.Length);
								strData = Encoding.ASCII.GetString(buffer, 0, bytes);			
								
								//Output console
								Console.WriteLine("reviced : " + strData);
								
								bDataAv = true;
							}
						}
					}
					//if command = close, close tcp socket
					if (strcommands[i].ToString() == "close")
					{
						Console.WriteLine("close socket: yes");
						inOut.Close();
						c.Close();
						bisOpen = false;
					}
					else
					{
						switch (strcommands[i].ToString())
						{
							case "send":
								//safe in an string
								string send = strcommanddata[i];
								
								//replace \\n (no control char) to \n (control char)
								send = send.Replace("\\n", System.Environment.NewLine);
								
								//covnert commanddata to Byte
								byte[] sendBytes = Encoding.ASCII.GetBytes(send);
								
								//send data
								inOut.Write(sendBytes, 0, sendBytes.Length);
								
								//output for console
								Console.WriteLine("send data: " + @send);
								break;
							case "sleep":
								//standard parameter is 3 seconds
								if (strcommanddata[i] == "")
								{
									Console.WriteLine("sleep: 3000 miliseconds");
									System.Threading.Thread.Sleep(3000);
								}
								else
								{
									int isleep = 1000 * Convert.ToInt32(strcommanddata[i].Trim());
									System.Threading.Thread.Sleep(isleep);
									Console.WriteLine("sleep: " + isleep.ToString() + " miliseconds");
								}
								break;
							case "icmp_alive":	
								//hostname to ip
								string strIP = null;
								try
								{
									IPHostEntry IPHost = Dns.Resolve(gstrHost);
									strIP = Convert.ToString(IPHost.AddressList[0]);
								}
								catch (SocketException sexc)
								{
									Console.WriteLine(sexc.Message);
								}
								
								//ping
								ICMP vPing = new ICMP();
								vPing.Open();
								TimeSpan span = vPing.Send(strIP, new TimeSpan(0,0,5));
								
								if (span == TimeSpan.MaxValue)
								{
									Console.WriteLine("ping: no");
								}
								else
									Console.WriteLine("ping: yes");
								break;
							case "pattern_exists":
								try
								{
									//if no data aviable no check
									if (strData != "" && bDataAv)
									{
										Console.WriteLine("pattern exist: yes");
								
										//may be there is pattern exist between other commands and not at the end
										if (strcommanddata[i] == "")
										{
											Console.WriteLine("pattern exists: no data");
											if (strcommands[strcommands.Length -1] == "pattern_exists")
											{
												strcommanddata[i] = strcommanddata[strcommanddata.Length -1];
											}
										}
										
										//check to the rearched chars
										string strex = strcommanddata[i];
										
										//compatibility between the differents kind of regular expressions
										strex = strex.Replace("OR", "|");
										strex = strex.Replace("AND", "&");
									
										//a "*" at the begin of the expression is in .net not needed
										//there are other possibilities for example string.StartWith
										int itemp = strex.IndexOf("*");
										if (itemp == 0)
										{
											Console.WriteLine("pattern exists: remove \"*\" at the start");
											strex = strex.Remove(0,1);
										}
									
										r1 = new Regex(@strex);
										mc = r1.Matches(strData);
										int count = mc.Count;								
										if (count > 0)
										{
											Console.WriteLine("pattern matches: yes");
										}
										else
											Console.WriteLine("pattern matches: no");
									}
									else
										Console.WriteLine("pattern exists: yes, but no expression data");
								}
								catch (ArgumentException aexc)
								{
									Console.WriteLine("! Sorry, the pattern exists expression is not compatible. Please don't use unauthorized escape chars. For more information see the documentation. !");
								}	
								break;						
						}
					}
				}
			
			}
			//catch socket exception for example connection refused
			catch (SocketException sexc)
			{
				Console.WriteLine(sexc.Message);
			}
			catch (Exception exc)
			{
				Console.WriteLine(exc.ToString());
			}
			finally
			{
				c.Close();
				inOut.Close();
			}	
		}
		
		public string mstrSplit(string input)
		{
			//this is only a workaround, I haven't a better idea
			string[] strtmp2 = input.Split('>');
			string strtmp3 = strtmp2[1];
			string[] strtmp4 = strtmp3.Split('<');
			return strtmp4[0];
		}
	}
}